> For the complete documentation index, see [llms.txt](https://docs.metacces.com/whitepaper/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.metacces.com/whitepaper/metacces-general/blockchain-layer-1/developers/smart-contracts/fixed-cap-asset.md).

# Fixed Cap Asset

Fixed-cap assets are fungible tokens for which the supply is determined at the time of asset creation. No additional quantities can be generated afterwards.

## Create the Asset <a href="#create-the-asset" id="create-the-asset"></a>

### 1. Write the token smart contract <a href="#id-1.-write-the-token-smart-contract" id="id-1.-write-the-token-smart-contract"></a>

<https://github.com/OpenZeppelin/openzeppelin-contracts/blob/master/contracts/token/ERC20/ERC20Capped.solgithub.comExtension> of ERC20 that adds a cap to the supply of tokensThis contract is designed to be unopinionated, allowing developers to access the internal functions in ERC20 (such as \_mint) and expose them as external functions in the way they prefer. On the other hand, ERC20 Presets (such as ERC20PresetMinterPauser) are designed using opinionated patterns to provide developers with ready to use, deployable contracts.

#### Functions <a href="#functions" id="functions"></a>

*Fixed-cap Assets*

* constructor(cap)
* cap()
* \_beforeTokenTransfer(from, to, amount)

*General*

* name()
* symbol()
* decimals()
* totalSupply()
* balanceOf(account)
* transfer(recipient, amount)
* allowance(owner, spender)
* approve(spender, amount)
* transferFrom(sender, recipient, amount)
* increaseAllowance(spender, addedValue)
* decreaseAllowance(spender, subtractedValue)
* \_transfer(sender, recipient, amount)
* \_mint(account, amount)
* \_burn(account, amount)
* \_approve(owner, spender, amount)
* \_setupDecimals(decimals\_)

### 2. Compile your code into bytecode <a href="#id-2.-compile-your-code-into-bytecode" id="id-2.-compile-your-code-into-bytecode"></a>

### 3. Deploy your Fixed-cap Asset by sending your code in a transaction to the Enter network <a href="#id-3.-deploy-your-fixed-cap-asset-by-sending-your-code-in-a-transaction-to-the-fantom-network" id="id-3.-deploy-your-fixed-cap-asset-by-sending-your-code-in-a-transaction-to-the-fantom-network"></a>

### 4. Navigate to the explorer to check that your token has been created <a href="#id-4.-navigate-to-the-explorer-to-check-that-your-token-has-been-created" id="id-4.-navigate-to-the-explorer-to-check-that-your-token-has-been-created"></a>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.metacces.com/whitepaper/metacces-general/blockchain-layer-1/developers/smart-contracts/fixed-cap-asset.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
